/*
 * This file was generated automatically by xsubpp version 1.9508 from the
 * contents of Statusbar.xs. Do not edit this file, edit Statusbar.xs instead.
 *
 *	ANY CHANGES MADE HERE WILL BE LOST!
 *
 */

#line 1 "Statusbar.xs"
#include "module.h"

static GHashTable *perl_sbar_defs;

static int check_sbar_destroy(char *key, char *value, char *script)
{
	if (strncmp(value, script, strlen(script)) == 0 &&
	    value[strlen(script)] == ':') {
                statusbar_item_unregister(key);
		g_free(key);
                g_free(value);
		return TRUE;
	}

        return FALSE;
}

static void script_unregister_statusbars(PERL_SCRIPT_REC *script)
{
	g_hash_table_foreach_remove(perl_sbar_defs,
				    (GHRFunc) check_sbar_destroy,
				    script->package);
}

void perl_statusbar_init(void)
{
	perl_sbar_defs = g_hash_table_new((GHashFunc) g_str_hash,
					  (GCompareFunc) g_str_equal);
	signal_add("script destroyed", (SIGNAL_FUNC) script_unregister_statusbars);
}

static void statusbar_item_def_destroy(void *key, void *value)
{
	statusbar_item_unregister(key);
	g_free(key);
        g_free(value);
}

void perl_statusbar_deinit(void)
{
	signal_remove("script destroyed", (SIGNAL_FUNC) script_unregister_statusbars);

	g_hash_table_foreach(perl_sbar_defs,
			     (GHFunc) statusbar_item_def_destroy, NULL);
	g_hash_table_destroy(perl_sbar_defs);
}

static void perl_statusbar_event(char *function, SBAR_ITEM_REC *item,
				 int get_size_only)
{
	dSP;
	int retcount;
	SV *item_sv, **sv;
        HV *hv;

	ENTER;
	SAVETMPS;

	PUSHMARK(SP);
        item_sv = plain_bless(item, "Irssi::TextUI::StatusbarItem");
	XPUSHs(sv_2mortal(item_sv));
	XPUSHs(sv_2mortal(newSViv(get_size_only)));
	PUTBACK;

	retcount = perl_call_pv(function, G_EVAL|G_DISCARD);
	SPAGAIN;

	if (SvTRUE(ERRSV)) {
                PERL_SCRIPT_REC *script;
                char *package;

                package = perl_function_get_package(function);
                script = perl_script_find_package(package);
                g_free(package);

		if (script != NULL) {
                        /* make sure we don't get back here */
			script_unregister_statusbars(script);
		}
		signal_emit("script error", 2, script, SvPV(ERRSV, PL_na));
	} else {
		/* min_size and max_size can be changed, move them to SBAR_ITEM_REC */
		hv = hvref(item_sv);
		if (hv != NULL) {
			sv = hv_fetch(hv, "min_size", 8, 0);
			if (sv != NULL) item->min_size = SvIV(*sv);
			sv = hv_fetch(hv, "max_size", 8, 0);
			if (sv != NULL) item->max_size = SvIV(*sv);
		}
	}

	PUTBACK;
	FREETMPS;
	LEAVE;
}


static void sig_perl_statusbar(SBAR_ITEM_REC *item, int get_size_only)
{
	char *function;

	function = g_hash_table_lookup(perl_sbar_defs, item->config->name);
	if (function != NULL)
		perl_statusbar_event(function, item, get_size_only);
	else {
		/* use default function - this shouldn't actually happen.. */
		statusbar_item_default_handler(item, get_size_only, NULL, "", TRUE);
	}
}

#line 121 "Statusbar.c"

XS(XS_Irssi_statusbar_item_register); /* prototype to pass -Wmissing-prototypes */
XS(XS_Irssi_statusbar_item_register)
{
    dXSARGS;
    if (items < 2 || items > 3)
	Perl_croak(aTHX_ "Usage: Irssi::statusbar_item_register(name, value, func = NULL)");
    {
	char *	name = (char *)SvPV_nolen(ST(0));
	char *	value = (char *)SvPV_nolen(ST(1));
	char *	func;

	if (items < 3)
	    func = NULL;
	else {
	    func = (char *)SvPV_nolen(ST(2));
	}
#line 120 "Statusbar.xs"
	statusbar_item_register(name, value, func == NULL || *func == '\0' ? NULL : sig_perl_statusbar);
	if (func != NULL) {
		g_hash_table_insert(perl_sbar_defs, g_strdup(name),
				    g_strdup_printf("%s::%s", perl_get_package(), func));
	}
#line 145 "Statusbar.c"
    }
    XSRETURN_EMPTY;
}


XS(XS_Irssi_statusbar_item_unregister); /* prototype to pass -Wmissing-prototypes */
XS(XS_Irssi_statusbar_item_unregister)
{
    dXSARGS;
    if (items != 1)
	Perl_croak(aTHX_ "Usage: Irssi::statusbar_item_unregister(name)");
    {
	char *	name = (char *)SvPV_nolen(ST(0));
#line 130 "Statusbar.xs"
        gpointer key, value;
#line 161 "Statusbar.c"
#line 132 "Statusbar.xs"
	if (g_hash_table_lookup_extended(perl_sbar_defs, name, &key, &value)) {
                g_hash_table_remove(perl_sbar_defs, name);
		g_free(key);
                g_free(value);
	}
	statusbar_item_unregister(name);
#line 169 "Statusbar.c"
    }
    XSRETURN_EMPTY;
}


XS(XS_Irssi_statusbar_items_redraw); /* prototype to pass -Wmissing-prototypes */
XS(XS_Irssi_statusbar_items_redraw)
{
    dXSARGS;
    if (items != 1)
	Perl_croak(aTHX_ "Usage: Irssi::statusbar_items_redraw(name)");
    {
	char *	name = (char *)SvPV_nolen(ST(0));

	statusbar_items_redraw(name);
    }
    XSRETURN_EMPTY;
}


XS(XS_Irssi_statusbars_recreate_items); /* prototype to pass -Wmissing-prototypes */
XS(XS_Irssi_statusbars_recreate_items)
{
    dXSARGS;
    if (items != 0)
	Perl_croak(aTHX_ "Usage: Irssi::statusbars_recreate_items()");
    {

	statusbars_recreate_items();
    }
    XSRETURN_EMPTY;
}


XS(XS_Irssi__TextUI__StatusbarItem_default_handler); /* prototype to pass -Wmissing-prototypes */
XS(XS_Irssi__TextUI__StatusbarItem_default_handler)
{
    dXSARGS;
    if (items < 4 || items > 5)
	Perl_croak(aTHX_ "Usage: Irssi::TextUI::StatusbarItem::default_handler(item, get_size_only, str, data, escape_vars = TRUE)");
    {
	Irssi__TextUI__StatusbarItem	item = irssi_ref_object(ST(0));
	int	get_size_only = (int)SvIV(ST(1));
	char *	str = (char *)SvPV_nolen(ST(2));
	char *	data = (char *)SvPV_nolen(ST(3));
	int	escape_vars;
#line 158 "Statusbar.xs"
	HV *hv;
#line 218 "Statusbar.c"

	if (items < 5)
	    escape_vars = TRUE;
	else {
	    escape_vars = (int)SvIV(ST(4));
	}
#line 160 "Statusbar.xs"
	statusbar_item_default_handler(item, get_size_only,
				       *str == '\0' ? NULL : str,
				       data, escape_vars);
	hv = hvref(ST(0));
	hv_store(hv, "min_size", 8, newSViv(item->min_size), 0);
	hv_store(hv, "max_size", 8, newSViv(item->max_size), 0);
#line 232 "Statusbar.c"
    }
    XSRETURN_EMPTY;
}

#ifdef __cplusplus
extern "C"
#endif
XS(boot_Irssi__TextUI__Statusbar); /* prototype to pass -Wmissing-prototypes */
XS(boot_Irssi__TextUI__Statusbar)
{
    dXSARGS;
    char* file = __FILE__;

    XS_VERSION_BOOTCHECK ;

        newXSproto("Irssi::statusbar_item_register", XS_Irssi_statusbar_item_register, file, "$$;$");
        newXSproto("Irssi::statusbar_item_unregister", XS_Irssi_statusbar_item_unregister, file, "$");
        newXSproto("Irssi::statusbar_items_redraw", XS_Irssi_statusbar_items_redraw, file, "$");
        newXSproto("Irssi::statusbars_recreate_items", XS_Irssi_statusbars_recreate_items, file, "");
        newXSproto("Irssi::TextUI::StatusbarItem::default_handler", XS_Irssi__TextUI__StatusbarItem_default_handler, file, "$$$$;$");
    XSRETURN_YES;
}

